%define section free
%define uscver 2.1_3

Summary:        Code Generation Library
Name:           cglib
Version:        2.1.3
Release:        1jpp
Epoch:          0
License:        Apache Software License 2
URL:            http://cglib.sourceforge.net/
Group:          Development/Libraries/Java
Vendor:         JPackage Project
Distribution:   JPackage
Source0:        cglib-src-2.1_3.jar
Source1:        cglib-missing-words.txt
Patch0:         cglib-2.1.3-build_xml.patch
Patch1:         cglib-ExamplePreProcessor.patch
BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:  ant >= 0:1.6
BuildRequires:  ant-junit >= 0:1.6
BuildRequires:  jarjar
BuildRequires:  junit
BuildRequires:  asm  >= 0:1.5.3
BuildRequires:  asm2
BuildRequires:  aspectwerkz >= 0:1.0
Requires:  asm >= 0:1.5.3
Requires:  aspectwerkz >= 0:1.0
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
cglib is a powerful, high performance and quality 
Code Generation Library, It is used to extend JAVA 
classes and implements interfaces at runtime.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -T -c -n %{name}
unzip -q %{SOURCE0}
# remove all binary libs
for f in $(find . -name "*.jar"); do mv $f $f.no; done
( cat << EO_JP
grant codeBase "file:/-"{
  permission java.security.AllPermission;
};
EO_JP
) > java.policy
# add missing test input file
cp %{SOURCE1} src/test/net/sf/cglib/util/words.txt

%patch0 -b .sav
%patch1 -b .sav

%build
build-jar-repository -s -p lib \
ant \
asm/asm-attrs \
asm/asm \
asm2/asm2 \
asm/asm-util \
aspectwerkz-core \
jarjar \
junit \

ant test javadoc jar

%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p dist/%{name}-%{uscver}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
cp -p dist/%{name}-nodep-%{uscver}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-nodep-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
rmdir docs/api
cp -pr docs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p LICENSE $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}


%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}/LICENSE
%{_javadir}/*.jar

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/*

# -----------------------------------------------------------------------------

%changelog
* Fri Nov 11 2005 Ralph Apel <r.apel at r-apel.de> - 0:2.1.3-1jpp
- Upgrade to 2.1_3
- asm2 is BuildRequired too, because our newer jarjar needs it

* Tue Mar 15 2005 Ralph Apel <r.apel at r-apel.de> - 0:2.1.0-1jpp
- Adapt to upgraded asm 1.5.3 (no src patching required)

* Tue Feb 01 2005 Ralph Apel <r.apel at r-apel.de> - 0:2.0.2-2jpp
- Adapt to upgraded asm 1.4.3 (patch required)

* Wed Sep 08 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0.2-1jpp
- Upgrade to 2.0.2 (bug fix required)
- Drop cglib-full.jar (identical to cglib.jar in our build)
- Add manual generated offline with "maven xdoc:transform"

* Tue Sep 07 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0.1-3jpp
- Include cglib-full.jar in package

* Mon Sep 06 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0.1-2jpp
- Upgrade to Ant 1.6.X
- Build with ant-1.6.2
- Relax some versioned dependencies
- Add missing BuildReq junit
- Upgraded to 2.0.1 and built with aspectwerkz-0.9 on Sat Jun 12 2004 
  by Ralph Apel <r.apel at r-apel.de> as 0:2.0.1-1jpp

* Fri Aug 20 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0-3jpp
- Build with ant-1.6.2
- Dropped ant from CLASSPATH
- Relaxed jpackage-utils BuildReq

* Tue Jun 01 2004 Randy Watler <rwatler at finali.com> - 0:2.0-2jpp
- Upgrade to Ant 1.6.X

* Sat Feb 28 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.0-1jpp
- First JPackage release
